<?

function get_contentgroup_menu( $link )
{
global $STAG, $FEATURE, $FOLDER_ID, $USER_ID, $T_FOLDER, $T_PAGE;
$menu_lang = i18n('language');
$mnu_lang = array("", $menu_lang, "$STAG", "list", "mnunode", "l");
$MENU = array();
if ($FEATURE["contentgroup3"]) {
$cs = $info['contentset_id'];
$cg = get_contentgroups();
if (count($cg) > 0 ) {
$MENU[] = $mnu_lang;
foreach ($cg as $cg_id => $v) {
if( !perm( $USER_ID, $T_FOLDER, $FOLDER_ID, 11, $cg_id, $T_PAGE, 10 ) ) {
//                                                                                    
 continue;
}
$page_icon = get_pageicon(0, $v['code']);
$MENU[] = array($menu_lang, $v['name'], "$STAG&CONTENTGROUP_ID=$cg_id&$link", "list", "mnunode", "l", $page_icon);
}
}
}
return $MENU;
}

function get_contentgroups($node_id = "") {

global $NODE_ID;

static $CACHE=array();

if (!$node_id) $node_id = $NODE_ID;
$node_id = getMasterNode($node_id);
if ( isset( $CACHE[$node_id] ) ) return $CACHE[$node_id];
//                                                                        

$arr = Array();
if ($node_id)
$sql = "SELECT id, name, code FROM contentgroup, node_contentgroup WHERE node_contentgroup.contentgroup_id = contentgroup.id AND node_contentgroup.node_id = ".sqlf_tl_num($node_id)." ORDER BY node_contentgroup.sortorder";
else $sql = "SELECT id, name, code FROM contentgroup";
$rs = query($sql);//            
 $cg = $rs["arr"];
while (list($key,$val) = each($cg)) {
$arr[$val['id']]['name'] = $val['name'];
$arr[$val['id']]['code'] = $val['code'];
}
$CACHE[$node_id] = $arr;
return $arr;

}

/**
 *                                                                                
 *                              
 */
function get_all_contentgroups() {
global $USER_ID, $T_DOMAIN;

//                                         
 $sql = "SELECT node.folder_id as id, node.id as node_id from node";
$rs = query($sql);//            

$nodes = array();
if ($rs["arr"]) {
while (list($key,$val) = each($rs["arr"])) {
//                                                     
 if (perm($USER_ID,$T_DOMAIN,$val["id"],0)) {
$nodes[] = $val["node_id"];
}
}

if ( count($nodes) > 0) {
$sql = "SELECT id, name, code FROM contentgroup, node_contentgroup WHERE node_contentgroup.contentgroup_id = contentgroup.id AND node_contentgroup.node_id IN (".implode(",", sqlf_tl_num_array($nodes)).") ORDER BY node_contentgroup.sortorder";
$rs = query($sql);//            
 $cg = $rs["arr"];
while (list($key,$val) = each($cg)) {
$arr[$val['id']]['name'] = $val['name'];
$arr[$val['id']]['code'] = $val['code'];
}
return $arr;
}
}

return array();
}

/**
 *                                                                                                  
 *                                                              
 *                                                                  
 */
function get_all_contentgroup_menu( $link ) {
global $STAG, $FEATURE, $FOLDER_ID, $USER_ID, $T_FOLDER, $T_PAGE;
$menu_lang = i18n('language');
$mnu_lang = array("", $menu_lang, "$STAG", "list", "mnunode", "l");
$MENU = array();
if ($FEATURE["contentgroup3"]) {
$cg = get_all_contentgroups();
if (count($cg) > 0 ) {
$MENU[] = $mnu_lang;
foreach ($cg as $cg_id => $v) {
$page_icon = get_pageicon(0, $v['code']);
$MENU[] = array($menu_lang, $v['name'], "$STAG&CONTENTGROUP_ID=$cg_id&$link", "list", "mnunode", "l", $page_icon);
}
}
}
return $MENU;
}

function get_contentgroup_ass( $contentgroup_id = false, $all_nodes = false )
{
global $FEATURE, $CONTENTGROUP_ID;
if ( $contentgroup_id === false ) $contentgroup_id = $CONTENTGROUP_ID;
if ( $FEATURE["contentgroup3"] && $contentgroup_id )
{
$cg = $all_nodes ? get_all_contentgroups() : get_contentgroups();
if ( $cg[$contentgroup_id]["name"] )
//                                             
 return  img(get_pageicon(2, $cg[$contentgroup_id]["code"]),0,$cg[$contentgroup_id]["name"]) . " " . $cg[$contentgroup_id]["code"];
}
return "";
}

/**
 *                                                                                                              
 **/
function get_contentId_for_contentgroup($content_id, $contentgroup_id) {

global $FEATURE, $SQLAS;

//                                                           
 if (!$FEATURE["contentgroup3"] || !$contentgroup_id) return $content_id;

//                                             
 $sql = "SELECT page.id, page.content_id FROM page, page $SQLAS cpage 
	  WHERE cpage.content_id = ".sqlf_tl_num($content_id)." AND cpage.contentset_id = page.contentset_id AND page.contentgroup_id = ".sqlf_tl_num($contentgroup_id);
$rs = query($sql);//            
 if ($rs["num"]) {
return $rs["arr"][0]["content_id"];
} else {
//                                                              
 //                                         
 return $content_id;
}

return $content_id;
}

function get_contentId_for_contentset($contentset_id, $contentgroup_id) {

global $FEATURE, $SQLAS;

//                                          
 if (!$contentset_id || !$FEATURE["contentgroup3"]) return 0;

//                                                                                                                               
 //                                                        
 $sql = "SELECT page.content_id FROM page, page $SQLAS cpage, page $SQLAS opage 
	WHERE page.contentgroup_id = ".sqlf_tl_num($contentgroup_id)." AND cpage.contentset_id = page.contentset_id AND cpage.content_id = opage.content_id
	  AND opage.contentset_id = ".sqlf_tl_num($contentset_id);
$rs = query($sql);//            
 if ($rs["num"]) {
return $rs["arr"][0]["content_id"];
} else {
return 0;
}

return 0;
}

?>
