<?

class PageSelector extends MinibrowserWrapper {

var $d_mb = NULL;
var $d_enableDirectLanguageSelection = TRUE;
var $d_rootType, $d_rootId, $d_pageId;

function PageSelector ($root_id = 0, $root_type = 0, $page_id = 0) {
global $T_CONTENT;
if (!$root_type && !$root_id) {
$root_type = $T_CONTENT;
$sql = "SELECT id FROM tree WHERE type_id = ".sqlf_tl_num($T_CONTENT);
$rs = query($sql);//            
 $root_id = $rs["arr"][0]["id"];
}
$this->d_rootType = $root_type;
$this->d_rootId = $root_id;
$this->d_pageId = $page_id;
}

function getSerializeKey()
{
return array(
"parent"=>parent::getSerializeKey(),
"mnbr"=>node_serialize( $this->d_mb )
);
}

function initFromSerializeKey( $key )
{
parent::initFromSerializeKey( $key["parent"] );
$this->d_mb = &node_unserialize( $key["mnbr"] );
}


function setRoot ($o_id, $o_type) {
$this->d_mb->setRootID($o_id);
$this->d_mb->setRootType($o_type);
}

function enableDirectLanguageSelection( $enable = TRUE )
{
$this->d_enableDirectLanguageSelection = $enable;
}

function setObject(&$obj) {
if (is_a($obj, "cnpageobject")) {
$this->setPageID($obj->getID());
}
}

function initObject($type, $id) {
$this->setPageID($id);
}

function getObjectType () {
global $T_PAGE;
return $T_PAGE;
}

function getObjectID() {
return $this->d_mb->getResultID();
}

function setPageID($id) {
global $T_FOLDER;
$id = (int) $id;
$sql = "SELECT folder_id FROM page WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);//            
 $this->d_mb->setFolder($rs["arr"][0]["folder_id"], $T_FOLDER);
$this->d_mb->setResultID(1, $id);
$this->d_mb->setStep(1);
}


function getPageID() {
return $this->d_mb->getResultID();
}

function &getMinibrowser() {
$this->createMinibrowser();
node_var("T_TYPE");
return $this->d_mb;
}

function createMinibrowser () {
if ( !is_null( $this->d_mb ) ) return;


global $T_FOLDER, $T_NODE, $ICO_PAGE;
node_class("minibrowser");


node_class( "minipagedatasource" );
$ds = new MiniPageDatasource ();
$ds->setColumn( "name", i18n( "Page" ), true, true );
if ( $this->d_enableDirectLanguageSelection )
$ds->setColumn( "lang_link", i18n( "Language" ), true );
$ds->showColumnHeader(true);

$this->d_mb = new MiniBrowser($this->d_rootId, $this->d_rootType);
$this->d_mb->addType($T_FOLDER);
$this->d_mb->addType($T_NODE);
$this->d_mb->addStepDS($ds);
$this->d_mb->setHeader(i18n("Select Page"));

if ($this->d_pageId) $this->setPageID($this->d_pageId);

}

function getText() {
$this->createMinibrowser();
$page = new CNPageObject($this->d_mb->getResultID());
$name = $page->getProperty("name");
return $name->toString();
}

function getResultObject() {
$this->createMinibrowser();
return new CNPageObject($this->d_mb->getResultID());
}

}


?>
