<?

class LdapObject extends NodeObject {

var $lBaseDn;
var $lHandle;
var $lDnField;
var $lFields;

var $lDn;
var $lType;

function LdapObject($id, $type = false) {
global $T_LDAPOBJECT;
if (!$type) $type = $T_LDAPOBJECT;
$this->lType = $type;
parent::NodeObject($id);
}

function getTType() {
return $this->lType;
}

function setHandle($handle) {
$this->lHandle = $handle;
}

function setBaseDn($basedn) {
$this->lBaseDn = $basedn;
}

function setDnField($dn) {
$this->lDnField = $dn;
}

function setFields($fields) {
$this->lFields = $fields;
}

function getDn() {
$dn = $this->lDnField."=".$this->getID().",".$this->lBaseDn;
return $dn;
}

function _setID($id) {
$this->lDn = $id;
}

function getID() {
return $this->lDn;
}

function getValueFields() {
$rs = array();

foreach ($this->lFields as $field) {
$rs[$field["ldapname"]] = false;
}

return $rs;
}

function checkErrors() { }

function _initObject() {

$cmd["cmd"] = "select";
$cmd["type"] = "base";
$cmd["basedn"] = $this->lBaseDn;
$cmd["filter"] = "(".$this->lDnField."=".$this->getID().")";
$cmd["attr"] = "*";
$rs = query($cmd, $this->lHandle);//         

if (count($rs) == 0) return false;

foreach ($rs["arr"][0] as $key=>$fields) {
if (count($fields) == 1) $fields = $fields[0];
$this->setFieldValue($key, $fields, true);
}

return true;
}

function _insertObject() {

}

function _updateObject() {

$attr = array();
$dattr = array();
foreach ( $this->lFields as $field ) {
$val = $this->getFieldValue($field["ldapname"]);
if ($val === "" || $val === NULL) {
$dattr[$field["ldapname"]] = array();
} else {
$attr[$field["ldapname"]] = $val;
}
}

$cmd["cmd"] = "update";
$cmd["dn"] = $this->getDn();
$cmd["attr"] = $attr;

$rs = query($cmd, $this->lHandle);//         

if (count($dattr)) {
$cmd["cmd"] = "delete";
$cmd["dn"] = $this->getDn();
$cmd["attr"] = $attr;
$rs = query($cmd, $this->lHandle) && $rs;//         
 }

return $rs;
}

function _deleteObject() {

}
}

class LdapFormObject extends NodeFormObject {

}

?>
